! -*- F90 -*-
      program GUGA
        call header
        call driver
      end program GUGA

      subroutine header
        write(6,*)
        write(6,*) ' -------------------------------------------- '
        write(6,*)
        write(6,*) ' Implementation of the GUGA from the papers '
        write(6,*) '    of Shavitt and Shepard '
        write(6,*)
        write(6,*) '   Peter Reinhardt (Paris) 10/2014 ' 
        write(6,*) '       using IRPF90  ' 
        write(6,*)
        write(6,*) ' -------------------------------------------- '
        write(6,*)
      end subroutine header

      subroutine driver
        implicit none
        integer :: i,j,k,a,b,jj,s

        write(6,*)
        write(6,*) ' vertices ----------------------------------------- '
        write(6,*)
        do i=norbitals,0,-1
         write(6,*) ' level ',i
         do j=1,nvertex
          a=table_a(j)
          b=table_b(j)
          if (vertex(i,j).ne.0) then
           write(6,9901) a,b,vertex(i,j)
9901       format('   vertex (',i2,',',i2,') = ',i8)
          end if
         end do
        end do

        write(6,*)
        write(6,*) ' arcs ----------------------------------------- '
        write(6,*)
        do i=norbitals-1,0,-1
         write(6,*) ' level ',i
         do j=1,nvertex
          a=table_a(j)
          b=table_b(j)
          if (vertex(i,j).ne.0) then
! is the vertex in the higher level zero ?
! s=0
           s=0
           if (vertex(i+1,j).ne.0) then
            write(6,9902) s,i,a,b,i+1,a,b,arc(i,s,j)
           end if
! s=1
           s=1
           if (b.lt.spin+amax-a) then
            jj=table_ab_inv(a,b+1)
            if (vertex(i+1,jj).ne.0) then
             write(6,9902) s,i,a,b,i+1,a,b+1,arc(i,s,j)
            end if
           end if
           if (a.lt.amax) then
! s=2
            if (b.gt.0) then
             jj=table_ab_inv(a+1,b-1)
             s=2
             if (vertex(i+1,jj).ne.0) then
              write(6,9902) s,i,a,b,i+1,a+1,b-1,arc(i,s,j)
             end if
            end if
! s=3
            s=3
            jj=table_ab_inv(a+1,b)
            if (jj.ne.-1) then
             if (vertex(i+1,jj).ne.0) then
              write(6,9902) s,i,a,b,i+1,a+1,b,arc(i,s,j)
             end if
            end if
           end if
          end if
         end do
        end do
9902    format('    arc type ',i1,' linking (',3i3, &
             ') to (',3i3,') has weight ',i6) 
        write(6,*)
        write(6,*)

        write(6,*) ' constructed ',ntot_csf,' CSFs '

        write(6,*)
        write(6,*) ' right-most walk --------------------------- '
        write(6,*)
        do i=norbitals,0,-1
         write(6,'(2i3)') paldusvector(1,i),paldusvector(2,i)
        end do

      end subroutine driver



