! -*- F90 -*-
BEGIN_PROVIDER [integer, N_CSF]
     n_csf=vertex(0,nvertex)
END_PROVIDER

BEGIN_PROVIDER [integer, stepvector, (norbitals) ]
END_PROVIDER

BEGIN_PROVIDER [integer, DeltaP, (2,0:3) ]
   DeltaP(1,0)= 0
   DeltaP(2,0)= 0
   DeltaP(1,1)= 0
   DeltaP(2,1)= 1
   DeltaP(1,2)= 1
   DeltaP(2,2)=-1
   DeltaP(1,3)= 1
   DeltaP(2,3)= 0
END_PROVIDER


BEGIN_PROVIDER [integer, paldusvector, (2,0:norbitals) ]
 paldusvector(1,0)=0
 paldusvector(2,0)=0
END_PROVIDER

 BEGIN_PROVIDER [integer, ntot_csf ]
&BEGIN_PROVIDER [integer, paldusarray, (n_csf,0:norbitals) ]
     implicit none
     integer :: i,j,a,b,jj,weight,indx,indx1,ntst,n
     logical :: try3,found,exist,stepdown

     do i=1,n_csf
      do jj=0,norbitals
       paldusarray(i,jj)=0
      end do
     end do
!
! walk through all paths, add up the arcs encountered, generate the 
! Paldus vector and store it in the table, we have to count in base 3 
! from zero up to 4**norbitals. If an intermediate node does not exit, we do 
! not need to count all higher levels at all.

     do i=1,norbitals
      stepvector(i)=0
     end do
     ntot_csf=0
! determine right-most walk, starting from vertex (0,j)

     found=.true.
     
     j=nvertex
     a=table_a(j)
     b=table_b(j)
     weight=1
     do i=1,norbitals
! does vertex (i,j+stepvector exist) ?
! s=0
      if (vertex(i,j).ne.0) then
       weight=weight+arc(i-1,0,j)
!       write(6,*) i,': found 0 '
      else
! if not, try 1
       stepvector(i)=1
       if (b.le.spin+amax-a) then
        jj=table_ab_inv(a,b+1)
        if (vertex(i,jj).ne.0) then
         weight=weight+arc(i-1,1,j)
         j=jj
         a=table_a(j)
         b=table_b(j)
!         write(6,*) i,': found 1 '
        else
         if (a.lt.amax) then
! if not, try 2
          if (b.gt.0) then
           try3=.false.
           stepvector(i)=2
           jj=table_ab_inv(a+1,b-1)
           if (vertex(i,jj).ne.0) then
            weight=weight+arc(i-1,2,j)
            j=jj
            a=table_a(j)
            b=table_b(j)
!            write(6,*) i,': found 2 '
           else
            try3=.true.
           end if
          end if
          
          if (b.eq.0.or.try3) then
! if not, try 3, it must be 3
!          write(6,*) i,': try3 '
          stepvector(i)=3
          jj=table_ab_inv(a+1,b)
!          write(6,*) ' trying vertex No ',i,jj,a+1,b
          if (vertex(i,jj).ne.0) then
           weight=weight+arc(i-1,3,j)
!           write(6,*) i,': found 3 ',a+1,b
           j=jj
           a=table_a(j)
           b=table_b(j)
!           write(6,*) ' setting j to ',jj
          else
           stop ' something went wrong '
          end if
         end if
        else
         stop ' need too high a value for AMAX ' 
        end if
       end if
      end if
     end if
    end do
!   
    ntot_csf=ntot_csf+1
    ntst=1

!!$    write(6,*)
!!$    write(6,*) ' right-most stepvector has number ',weight
!!$    write(6,*) ' sequence from 0 to norbitals : '
!!$    write(6,'(20i2)') (stepvector(i),i=1,norbitals)


    write(6,*)
    write(6,9010) weight, (stepvector(i),i=1,norbitals)

!
    do i=1,norbitals
     paldusarray(weight,i)=stepvector(i)
    end do

    do i=1,norbitals
     do j=1,2
      paldusvector(j,i)=deltaP(j,stepvector(i))
!      write(6,*) j,i,deltaP(j,stepvector(i))
     end do
    end do

! count stepvector up, test whether path exists

    do while (found)
     j=norbitals
     stepdown=.true.
     do while (stepdown)
      if (stepvector(j).eq.3) then
       stepvector(j)=0
       j=j-1
! exit the stepdown loop if bottom reached
       if (j.eq.0) exit
      else
       stepvector(j)=stepvector(j)+1
       stepdown=.false.
      end if
     end do

! exit as well the search for the existence of the walk
     if (j.eq.0) exit

!     write(6,9907) (stepvector(i),i=1,norbitals)
9907 format(' testing vector ',20I2)

! does this path exist ?

     exist=.true.
     j=0
     a=0
     b=0
     n=0
     indx1=nvertex
     indx=nvertex
     weight=1
     do while (exist)
      j=j+1
      if (j.eq.norbitals+1) exit
      if (stepvector(j).eq.0) then
       if (vertex(j,indx).eq.0) then
        exist=.false.
!        write(6,*) ' 0 zero vertex No ',j,indx
        do jj=j+1,norbitals
!         write(6,*) ' setting stepvector(',jj,') to 3 ' 
         stepvector(jj)=3
        end do
       else
! arc between (j-1,indx1) and (j,indx)
        weight=weight+arc(j-1,0,indx)
!        write(6,*) ' j, a, b ',j,a,b 
       end if
      else if  (stepvector(j).eq.1) then
       n=n+1 
       if (n.gt.nelectrons) then
        exist=.false.
        do jj=1+j,norbitals
         stepvector(jj)=3
        end do
        exit
       end if
!        write(6,*) ' --- j, a, b ',j,a,b+1 
       indx=table_ab_inv(a,b+1)
!       write(6,*) ' --- j, a, b+1, indx ',j,a,b+1,indx 
       if (indx.ne.-1) then
        if (vertex(j,indx).eq.0) then
         exist=.false.
!         write(6,*) ' 1 zero vertex No ',j,indx
         do jj=j+1,norbitals
!          write(6,*) ' setting stepvector(',jj,') to 3 ' 
          stepvector(jj)=3
         end do
        else
! arc between (j-1,indx1) and (j,indx)
         weight=weight+arc(j-1,1,indx1)
         indx1=indx
         b=b+1
!         write(6,*) ' j, a, b ',j,a,b 
        end if
       else
        exist=.false.
       end if
      else if  (stepvector(j).eq.2) then
       n=n+1 
       if (n.gt.nelectrons) then
        exist=.false.
        do jj=1+j,norbitals
         stepvector(jj)=3
        end do
        exit
       end if
       if (b.eq.0) then
        exist=.false.
!        write(6,*) ' 2 zero vertex No ',j,indx
        do jj=j+1,norbitals
!         write(6,*) ' setting stepvector(',jj,') to 3 ' 
         stepvector(jj)=3
        end do
       else
        indx=table_ab_inv(a+1,b-1)
        if (indx.ne.-1) then
         if (vertex(j,indx).eq.0) then
          exist=.false.
!          write(6,*) ' 2 zero vertex No ',j,indx
          do jj=j+1,norbitals
!           write(6,*) ' setting stepvector(',jj,') to 3 ' 
           stepvector(jj)=3
          end do
         else
! arc between (j-1,indx1) and (j,indx)
          weight=weight+arc(j-1,2,indx1)
          indx1=indx
          a=a+1
          b=b-1
!          write(6,*) ' j, a, b ',j,a,b 
         end if
        end if
       end if
      else if  (stepvector(j).eq.3) then
       n=n+2
       if (n.gt.nelectrons) then
        exist=.false.
        do jj=1+j,norbitals
         stepvector(jj)=3
        end do
        exit
       end if
       if (a.lt.amax) then 
        indx=table_ab_inv(a+1,b)
        if (indx.ne.-1) then
         if (vertex(j,indx).eq.0) then
          exist=.false.
!          write(6,*) ' 3 zero vertex No ',i,indx
          do jj=j+1,norbitals
!           write(6,*) ' setting stepvector(',jj,') to 3 ' 
           stepvector(jj)=3
          end do
         else
! arc between (j-1,indx1) and (j,indx)
          weight=weight+arc(j-1,3,indx1)
          indx1=indx
          a=a+1
!          write(6,*) ' j, a, b ',j,a,b 
         end if
        else
         exist=.false.
         do jj=j+1,norbitals
!          write(6,*) ' setting stepvector(',jj,') to 3 ' 
          stepvector(jj)=3
         end do
        end if
       else
        exist=.false.
        do jj=j+1,norbitals
!          write(6,*) ' setting stepvector(',jj,') to 3 ' 
         stepvector(jj)=3
        end do
       end if
      end if
     end do

     ntst=ntst+1

     if (exist) then
      ntot_csf=ntot_csf+1
      write(6,9010) weight,(stepvector(i),i=1,norbitals)
9010  format('     walk number ',I6,' has sequence ',30I2)
!
      do i=1,norbitals
       paldusarray(weight,i)=stepvector(i)
      end do
     end if

    end do
    
    write(6,*)
    write(6,*) ' found ',ntot_csf,' CSFs '
    write(6,*) ' tested ',ntst,' walks out of ',4.D0**norbitals,' possible ones '

    if (ntot_csf.ne.vertex(0,nvertex)) then
      write(6,*) ' found ',ntot_csf,' configurations '
      write(6,*) ' but we should have ',vertex(0,nvertex),' ones '
      stop ' ERROR '
    end if
     
END_PROVIDER



