! -*- F90 -*-
BEGIN_PROVIDER [integer, vertex, (0:norbitals,nvertex) ]
     implicit none
     integer :: i,j,a,b,jj
     logical :: elim

     write(6,*)
     write(6,*) ' generating vertices '

     do i=0,norbitals
      do j=1,nvertex
       vertex(i,j)=0
      end do
     end do
! starting point
     vertex(norbitals,1)=1
     do i=norbitals-1,0,-1
!      write(6,*) ' level ',i
      do j=1,nvertex
       a=table_a(j)
       b=table_b(j)
! we may have contributions from the stepvectors
!   3 : a+1,b
!   2 : a+1,b-1
!   1 : a,b+1
!   0 : a,b
!
!       write(6,*) ' treating vertex No ',j,' (',a,b,')' 
       if (a.lt.amax) then
!   3 : a+1,b
        jj=table_ab_inv(a+1,b)
        if (jj.ne.-1) then
!         write(6,*) '    contribution from s=3 ',vertex(i+1,jj),jj
         vertex(i,j)=vertex(i,j)+vertex(i+1,jj)
        end if
!   2 : a+1,b-1
        if (b.gt.0) then
         jj=table_ab_inv(a+1,b-1)
!         write(6,*) '    contribution from s=2 ',vertex(i+1,jj),jj
         vertex(i,j)=vertex(i,j)+vertex(i+1,jj)
        end if
       end if
!   1 : a,b+1
       if (b.lt.spin+amax-a) then
        jj=table_ab_inv(a,b+1)
!        write(6,*) '    contribution from s=1 ',vertex(i+1,jj),jj
        vertex(i,j)=vertex(i,j)+vertex(i+1,jj)
       end if
!   0 : a,b
!       write(6,*) '    contribution from s=0 ',vertex(i+1,j),j
       vertex(i,j)=vertex(i,j)+vertex(i+1,j)
      end do
     end do
!
! go back the graph in order to eliminate those walks not connected to (0,0,0) 
!
     do j=1,nvertex-1
      vertex(0,j)=0
     end do
!
     do i=1,norbitals-1
      do j=1,nvertex
       a=table_a(j)
       b=table_b(j)
       elim=.true.
! s=3
       if (a.ge.1) then
        jj=table_ab_inv(a-1,b)
        if (vertex(i-1,jj).ne.0) elim=.false.
! s=2
        jj=table_ab_inv(a-1,b+1)
        if (vertex(i-1,jj).ne.0) elim=.false.
       end if
! s=1
       jj=table_ab_inv(a,b-1)
       if (vertex(i-1,jj).ne.0) elim=.false.
! s=0 : 
       if (vertex(i-1,j).ne.0) elim=.false.
       if (elim) vertex(i,j)=0
      end do
     end do

     write(6,*) ' number of CSF expected : ',vertex(0,nvertex)


END_PROVIDER

BEGIN_PROVIDER [integer, nvertex]
    nvertex=(amax+1)*(spin+1)+amax*(amax+1)/2
    write(6,*) ' max numbers of vertices in a row = ',nvertex
END_PROVIDER

BEGIN_PROVIDER [integer, arc, (0:norbitals-1,0:3,nvertex) ]
       implicit none
       integer :: i,j,a,b,s,jj

       write(6,*)
       write(6,*) ' generating arcs '
       write(6,*)

       do i=1,norbitals
        do s=0,3
         do j=1,nvertex
          arc(i,s,j)=0
         end do
        end do
       end do

       do i=norbitals-1,0,-1
!        write(6,*) ' ---- level ',i
        do j=nvertex,1,-1
!         write(6,*) ' ---- nvertex ',j
         a=table_a(j)
         b=table_b(j)
! start from left, look for the corresponding vertex in the higher level
         arc(i,3,j)=0
!         write(6,*) ' s=3 ',j,a,b,arc(i,3,j)
! vertex with s=2, has weight as vertex from s=3, even if the arc does 
! not exist 
         if (a.lt.amax) then
          jj=table_ab_inv(a+1,b)
          if (jj.ne.-1) then
           arc(i,2,j)=vertex(i+1,jj)
!           write(6,*) ' s=2 ',j,jj,a,b,arc(i,2,j),vertex(i+1,jj)
          end if
         end if
! vertex with s=1 : a,b+1
         arc(i,1,j)=arc(i,2,j)
         if (b.lt.spin+amax-a.and.a.lt.amax.and.b.gt.0) then
          jj=table_ab_inv(a+1,b-1)
          arc(i,1,j)=arc(i,1,j)+vertex(i+1,jj)
!          write(6,*) ' XXXXX ',j,jj,a,b,arc(i,1,j),vertex(i+1,jj)
         end if
         arc(i,0,j)=vertex(i,j)-vertex(i+1,j)
        end do
       end do

END_PROVIDER

BEGIN_PROVIDER [integer, amax ]
    implicit none
    amax=(nelectrons-spin)/2
    write(6,*)
    write(6,*) ' max number of a_n in the Paldus arrays ',amax
END_PROVIDER

 BEGIN_PROVIDER [integer, table_a,     (nvertex) ]
&BEGIN_PROVIDER [integer, table_b,     (nvertex) ]
&BEGIN_PROVIDER [integer, table_ab_inv, (0:amax,0:spin+amax+amax) ]
      implicit none
      integer :: i,a,b

      write(6,*)
      write(6,*) ' generating index tables for one row'
      write(6,*)
      do a=0,amax
       do b=0,spin+amax+amax
        table_ab_inv(a,b)=-1
       end do
      end do

      i=0
      do a=amax,0,-1
       do b=spin+amax-a,0,-1
        i=i+1
        table_a(i)=a
        table_b(i)=b
        table_ab_inv(a,b)=i
       end do
      end do    
!!$      
!!$      write(6,*)
!!$      do i=1,nvertex
!!$       a=table_a(i)
!!$       b=table_b(i)
!!$       write(6,*) ' i,a,b,i = ',i,a,b,table_ab_inv(a,b)
!!$      end do
!!$      write(6,*)

!!$      do a=0,amax
!!$       do b=0,spin+amax+amax
!!$        write(6,*) ' a,b,i = ',a,b,table_ab_inv(a,b)
!!$       end do
!!$      end do

END_PROVIDER




